//+------------------------------------------------------------------+
//|                                         FX_Snipers_CCI_T3_3 .mq4 |
//|                                                                  |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//+------------------------------------------------------------------+
#property copyright "MojoFX - Conversion only"
#property link      ""//"http://groups.yahoo.com/group/MetaTrader_Experts_and_Indicators/"

#property indicator_separate_window
#property indicator_height  150
#property indicator_buffers 11
#property indicator_color1   Lavender
#property indicator_color2  DarkGreen
#property indicator_color3  Maroon
#property indicator_color4  Aqua
#property indicator_color5  Yellow
#property indicator_color6  Lime
#property indicator_color7  Red
#property indicator_color8  Aqua
#property indicator_color9  Yellow
#property indicator_color10  Lime
#property indicator_color11  Red
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1
#property indicator_width7  1
#property indicator_width8  1
#property indicator_width9  1
#property indicator_width10 4
#property indicator_width11 4
extern int CCI_Period      = 13; //50;
extern int T3_Period       = 13; //10;
extern double b            = 0.3;
extern double exit_0_level = 3;
extern double level        = 100;

// iCustom(NULL,0,"Null_BARS//T3new1",T3_Period,b,0,bar); 
double cci[];
double cciHup[];
double cciHdn[];
double cross_up_level[];
double cross_down_level[];
double down_in_up[];
double up_in_down[];
double cross_0_price_up[];
double cross_0_price_down[];
double excess_down_in_down_trend[];
double excess_up_in_up_trend[];
//----    
double e1[],e2[],e3[],e4[],e5[],e6[];
//----
double c1,c2,c3,c4;
double n,w1,w2,b2,b3;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
//---- 
IndicatorBuffers(17);
SetIndexStyle(0,DRAW_LINE);
IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
IndicatorShortName("T3"+T3_Period);
//---- indicators setting
    SetIndexBuffer(0, cci);
    SetIndexBuffer(1, cciHup);
    SetIndexBuffer(2, cciHdn);
//----
    SetIndexStyle(0, DRAW_LINE, 0, 2);
    SetIndexStyle(1, DRAW_HISTOGRAM,0,2);
    SetIndexStyle(2, DRAW_HISTOGRAM,0,2); 
//----        
    IndicatorShortName("FXST3CCI(" + CCI_Period + ", " + T3_Period + ")");
    SetIndexLabel(0, "FXST3CCI");     
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL); 
   
   SetIndexBuffer(3,cross_up_level);
   SetIndexStyle(3,DRAW_ARROW);  
   SetIndexArrow(3, 108);  
   SetIndexLabel(3,"bullish");
   
   SetIndexBuffer(4,cross_down_level);
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4, 108);  
   SetIndexLabel(4,"bearish");
   SetIndexEmptyValue(4,0.0);
  
   SetIndexBuffer(5,down_in_up);
   SetIndexStyle(5,DRAW_ARROW);  
   SetIndexArrow(5, 108);  
   SetIndexEmptyValue(5,0.0);
   
   SetIndexBuffer(6,up_in_down);
   SetIndexStyle(6,DRAW_ARROW);
   SetIndexArrow(6, 108);  
   SetIndexEmptyValue(6,0.0);
   
   SetIndexBuffer(7,cross_0_price_up);
   SetIndexStyle(7,DRAW_ARROW);  
   SetIndexArrow(7, 108);  
   SetIndexEmptyValue(7,0.0);
   
   SetIndexBuffer(8,cross_0_price_down);
   SetIndexStyle(8,DRAW_ARROW);
   SetIndexArrow(8, 108);  
   SetIndexEmptyValue(8,0.0);
   
   SetIndexBuffer(9,excess_down_in_down_trend );
   SetIndexStyle(9,DRAW_ARROW);  
   SetIndexArrow(9, 251);       //170
   SetIndexEmptyValue(9,0.0);

   SetIndexBuffer(10,excess_up_in_up_trend);
   SetIndexStyle(10,DRAW_ARROW);
   SetIndexArrow(10, 251);   //170   
   SetIndexEmptyValue(10,0.0);
//-------------------
  SetIndexBuffer(11,e1);
  SetIndexBuffer(12,e2);
  SetIndexBuffer(13,e3);
  SetIndexBuffer(14,e4);
  SetIndexBuffer(15,e5);
  SetIndexBuffer(16,e6);
//-------------------
   SetLevelValue(0, 0);
   SetLevelValue(1, level);
   SetLevelValue(2, -level);
   SetLevelStyle(STYLE_DOT,0,Yellow);     
//----------------------
b2=b*b;
b3=b2*b;
c1=-b3;
c2=(3*(b2+b3));
c3=-3*(2*b2+b+b3);
c4=(1+3*b+b3+3*b2);
n=T3_Period;
if (n<1) n=1;
n = 1 + 0.5*(n-1);
w1 = 2 / (n + 1);
w2 = 1 - w1;
//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{
//-------------------------------------------------------------- 10 --
if (Bars-1<T3_Period)return(0);
//----+        
int  MaxBar,limit,counted_bars=IndicatorCounted();
//----    
if (counted_bars<0)return(-1);
//----      
if (counted_bars>0) counted_bars--;
//----     ,        
MaxBar=Bars-1-T3_Period;
//----     ,         
limit=(Bars-1-counted_bars);
//----  
if (limit>MaxBar)
  {
   for(int bar=Bars-1; bar>=limit; bar--)
      {
      cci[bar]=0.0;
      down_in_up[bar]=0.0;
      up_in_down[bar]=0.0;
      cross_0_price_up[bar]=0.0;
      cross_0_price_down[bar]=0.0;
      excess_down_in_down_trend[bar]=0.0;
      excess_up_in_up_trend[bar]=0.0;
    }
   limit=MaxBar; 
  }

//+---    
for(bar=limit; bar>=0; bar--)
 {  
             cci[bar] = iCCI(NULL, 0, CCI_Period, PRICE_TYPICAL, bar);

//+---    
  e1[bar] = w1*cci[bar] + w2*e1[bar+1];
  e2[bar] = w1*e1[bar]  + w2*e2[bar+1];
  e3[bar] = w1*e2[bar]  + w2*e3[bar+1];
  e4[bar] = w1*e3[bar]  + w2*e4[bar+1];
  e5[bar] = w1*e4[bar]  + w2*e5[bar+1];
  e6[bar] = w1*e5[bar]  + w2*e6[bar+1];

  cci[bar]=c1*e6[bar] + c2*e5[bar] + c3*e4[bar] + c4*e3[bar];
// avoid repaintng 
      down_in_up[bar]=0.0;
      up_in_down[bar]=0.0;
      cross_0_price_up[bar]=0.0;
      cross_0_price_down[bar]=0.0;
      excess_down_in_down_trend[bar]=0.0;
      excess_up_in_up_trend[bar]=0.0;
//----
       if(cci[bar] >= 0)     cciHup[bar] = cci[bar];
       else                  cciHup[bar] = 0;          
       if(cci[bar] < 0 )     cciHdn[bar] = cci[bar];
       else                  cciHdn[bar] = 0; 
       
      if( cci[bar+1] > exit_0_level && cci[bar] < exit_0_level ) cross_0_price_down[bar] = exit_0_level;
      if( cci[bar+1] < -exit_0_level && cci[bar] > -exit_0_level  ) cross_0_price_up[bar] = -exit_0_level;
   
      if( cci[bar+1] < level && cci[bar] > level ) cross_up_level[bar] = level;
      if( cci[bar+1] > -level && cci[bar] < -level ) cross_down_level[bar] = -level;
   
      if( cci[bar] > level &&  cci[bar+2] < cci[bar+1] && cci[bar+1] > cci[bar] ) excess_up_in_up_trend[bar] =  cci[bar] +60;
      if( cci[bar] < -level && cci[bar+2] > cci[bar+1] && cci[bar+1] < cci[bar] )excess_down_in_down_trend [bar] = cci[bar] -60;;
      
    } 
  return(0);
  }